package org.jeecg.modules.spare.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.spare.entity.BuSparePart;
import org.jeecg.modules.spare.entity.BuSpareUseItem;
import org.jeecg.modules.spare.service.IBuSparePartService;
import org.jeecg.modules.spare.service.IBuSpareUseItemService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: 备件领用明细表
 * @Author: jeecg-boot
 * @Date:   2020-12-22
 * @Version: V1.0
 */
@Api(tags="备件领用明细表")
@RestController
@RequestMapping("/spare/buSpareUseItem")
@Slf4j
public class BuSpareUseItemController extends JeecgController<BuSpareUseItem, IBuSpareUseItemService> {
	@Autowired
	private IBuSpareUseItemService buSpareUseItemService;
	@Autowired
	private IBuSparePartService buSparePartService;


	 /**
	 * 分页列表查询
	 *
	 * @param buSpareUseItem
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@AutoLog(value = "备件领用明细表-分页列表查询")
	@ApiOperation(value="备件领用明细表-分页列表查询", notes="备件领用明细表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<?> queryPageList(BuSpareUseItem buSpareUseItem,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<BuSpareUseItem> queryWrapper = QueryGenerator.initQueryWrapper(buSpareUseItem, req.getParameterMap());
		Page<BuSpareUseItem> page = new Page<BuSpareUseItem>(pageNo, pageSize);
		IPage<BuSpareUseItem> pageList = buSpareUseItemService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	/**
	 *   添加
	 *
	 * @param buSpareUseItem
	 * @return
	 */
	@AutoLog(value = "备件领用明细表-添加")
	@ApiOperation(value="备件领用明细表-添加", notes="备件领用明细表-添加")
	@PostMapping(value = "/add")
	public Result<?> add(@RequestBody BuSpareUseItem buSpareUseItem) {
		BuSparePart a = buSparePartService.getSpareById(buSpareUseItem.getSpareId());
		int b = a.getNum();
		int c = buSpareUseItem.getNumber();
		int num = b - c;
		if (num>0&&num<=5) {
			a.setNum(num);
			buSparePartService.updateById(a);
			buSpareUseItemService.save(buSpareUseItem);
			return Result.ok("备件数量低于标准值，请补充备件");
		} else if (num<=0) {
			return Result.error("备件数量不足，无法领取");
		} else {
			a.setNum(num);
			buSparePartService.updateById(a);
			buSpareUseItemService.save(buSpareUseItem);
			return Result.OK("添加成功！");
		}
	}

	/**
	 *  编辑
	 *
	 * @param buSpareUseItem
	 * @return
	 */
	@AutoLog(value = "备件领用明细表-编辑")
	@ApiOperation(value="备件领用明细表-编辑", notes="备件领用明细表-编辑")
	@PutMapping(value = "/edit")
	public Result<?> edit(@RequestBody BuSpareUseItem buSpareUseItem) {
		buSpareUseItemService.updateById(buSpareUseItem);
		return Result.OK("编辑成功!");
	}

	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "备件领用明细表-通过id删除")
	@ApiOperation(value="备件领用明细表-通过id删除", notes="备件领用明细表-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<?> delete(@RequestParam(name="id",required=true) String id) {
		buSpareUseItemService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "备件领用明细表-批量删除")
	@ApiOperation(value="备件领用明细表-批量删除", notes="备件领用明细表-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<?> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.buSpareUseItemService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "备件领用明细表-通过id查询")
	@ApiOperation(value="备件领用明细表-通过id查询", notes="备件领用明细表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<?> queryById(@RequestParam(name="id",required=true) String id) {
		BuSpareUseItem buSpareUseItem = buSpareUseItemService.getById(id);
		if(buSpareUseItem==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(buSpareUseItem);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param buSpareUseItem
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BuSpareUseItem buSpareUseItem) {
        return super.exportXls(request, buSpareUseItem, BuSpareUseItem.class, "备件领用明细表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BuSpareUseItem.class);
    }

}
